SystemOrganization addCategory: #OLE!

SketchMorph subclass: #RippedOffMorph
	instanceVariableNames: 'target patch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:21'!
justDroppedInto: morph event: evt
	super justDroppedInto: morph event: evt.
	morph == patch ifTrue: [self replacePatch: morph].! !

!RippedOffMorph methodsFor: '*ole' stamp: 'lg 9/25/2007 12:07'!
replacePatch: patchMorph
	target extent: patchMorph extent; position: patchMorph position.
	patch owner replaceSubmorph: patchMorph by: target.
	OLE congratulate.! !

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:22'!
setPatch: morph 
	patch := morph.
! !

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 10:26'!
setTarget: morph 
	target := morph.
	self form: target imageForm.! !

!Morph methodsFor: '*ole-menus' stamp: 'lg 9/25/2007 11:31'!
addStandardHaloMenuItemsTo: aMenu hand: aHandMorph
	"Add standard halo items to the menu"

	| unlockables |

	self isWorldMorph ifTrue:
		[^ self addWorldHaloMenuItemsTo: aMenu hand: aHandMorph].

	self mustBeBackmost ifFalse:
		[aMenu add: 'send to back' translated action: #goBehind.
		aMenu add: 'bring to front' translated action: #comeToFront.
		self addEmbeddingMenuItemsTo: aMenu hand: aHandMorph.
		aMenu add: 'rip off' translated action: #ripoff.
		aMenu addLine].

	self addFillStyleMenuItems: aMenu hand: aHandMorph.
	self addBorderStyleMenuItems: aMenu hand: aHandMorph.
	self addDropShadowMenuItems: aMenu hand: aHandMorph.
	self addLayoutMenuItems: aMenu hand: aHandMorph.
	Preferences eToyFriendly ifFalse: [self addHaloActionsTo: aMenu].
	owner isTextMorph ifTrue:[self addTextAnchorMenuItems: aMenu hand: aHandMorph].
	aMenu addLine.
	self addToggleItemsToHaloMenu: aMenu.
	aMenu addLine.
	Preferences eToyFriendly ifFalse: [self addCopyItemsTo: aMenu].
	self addPlayerItemsTo: aMenu.
	Preferences eToyFriendly ifFalse: [self addExportMenuItems: aMenu hand: aHandMorph].
	Preferences eToyFriendly ifFalse: [self addStackItemsTo: aMenu].
	self addMiscExtrasTo: aMenu.
	Preferences eToyFriendly ifFalse: [Preferences noviceMode ifFalse:
		[self addDebuggingItemsTo: aMenu hand: aHandMorph]].

	aMenu addLine.
	aMenu defaultTarget: self.

	aMenu addLine.

	unlockables _ self submorphs select:
		[:m | m isLocked].
	unlockables size == 1 ifTrue:
		[aMenu
			add: ('unlock "{1}"' translated format: {unlockables first externalName})
			action: #unlockContents].
	unlockables size > 1 ifTrue:
		[aMenu add: 'unlock all contents' translated action: #unlockContents.
		aMenu add: 'unlock...' translated action: #unlockOneSubpart].

	aMenu defaultTarget: aHandMorph.
! !

!Morph methodsFor: '*ole' stamp: 'lg 9/25/2007 10:20'!
exchangeWith: morph 
	morph position: self position; extent: self extent.
	owner replaceSubmorph: self by: morph.! !

!Morph methodsFor: '*ole' stamp: 'lg 9/24/2007 17:00'!
ripOff
	| m |
	m := RipoffPatchMorph new initialize setTarget: self.
	owner addMorph: m after: self.
	owner removeMorph: self.
	self position: World activeHand position.
	World activeHand grabMorph: self.
! !

!Morph methodsFor: '*ole' stamp: 'lg 9/29/2007 13:03'!
ripoff
   | morph patch |
	morph := RippedOffMorph new setTarget: self.
	patch := RipoffPatchMorph new setTarget: morph.
	morph setPatch: patch.
	self exchangeWith: patch.
	morph center: World activeHand center.
	World activeHand grabMorph: morph.
! !

Morph subclass: #RipoffPatch
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RipoffPatch methodsFor: '*ole' stamp: 'lg 9/24/2007 17:54'!
setTarget: morph
	target := morph.
	self position: morph position; extent: morph extent.! !

Morph subclass: #RipoffPatchMorph
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/29/2007 13:03'!
initialize
	super initialize.
	self fillStyle: Color orange.
	self beSticky.
	self layoutPolicy: TableLayout new.
	self cellPositioning: #center; wrapCentering: #center; listCentering: #center.
	"XXX Add a text morph of a question mark"
	self cornerStyle: #rounded.
	! !

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 10:19'!
setTarget: ripoffMorph 
	target := ripoffMorph.! !

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:20'!
wantsDroppedMorph: morph event: evt
	^morph == target.

! !

Object subclass: #OLE
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!OLE class methodsFor: 'sound effects' stamp: 'lg 9/29/2007 13:02'!
congratulate
	"Not implemented" nil.! !

AlignmentMorph subclass: #DigitChooserMorph
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!DigitChooserMorph class methodsFor: 'as yet unclassified' stamp: 'lg 9/21/2007 14:07'!
additionsToViewerCategories
	^ #( (basic ((slot numericValue 'The most recently pressed digit (or zero, initially).' Number readWrite Player getNumericValue Player setNumericValue:))))! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 9/21/2007 13:37'!
addButtonRows
	| row |
	#( (1 2 3) (4 5 6) (7 8 9) ) do:
		[ :digits |
			row := AlignmentMorph newRow vResizing: #spaceFill; cellInset: 3; yourself.
			digits do: [ :d | row addMorphBack: (self buttonFor: d)].
			self addMorph: row]! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 9/21/2007 13:21'!
buttonFor: digit 
	^ SimpleButtonMorph new target: self;
		label: digit asString font: Preferences standardEToysButtonFont;
		actionSelector: #setProperty:toValue:;
		arguments: { #numericValue. digit };
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 9/21/2007 13:46'!
initialize
	super initialize.
	self extent: 300@300.
	self layoutPolicy: TableLayout new.
	self listDirection: #bottomToTop.
	self vResizing: #spaceFill.
	self cellInset: 3.
	self cellPositioning: #center.
	self listCentering: #justified.
	self wrapCentering: #justified.
	borderWidth := 2.
	self addButtonRows.
! !
